/* The routine adds a linear constraint to the optimization problem for a violated branch */

__declspec(dllexport) void addbrc(int il, int nclin, int nvar, int mrowa, double **amat, double *bl, double *bu, double *sens, int *preffrst, int *prefnext, double *told, int nbuses, int *ifromb, int *itob, int *igbus, double *xinv, double *pload, double *ratea)
{

    // Local variables
    double conmod;
    int ifr, itb, ig, ilast;

    // Calculate the sensitivity
    for (int ib = 0; ib < nbuses; ib++)
    {
        sens[ib] = 0.0;
    }

    ifr = ifromb[il];
    itb = itob[il];
    sens[ifr] = xinv[il];
    sens[itb] = -xinv[il];

    //CALL SOLVB(sens, nbuses);

    conmod = 0.0;
    nclin = nclin + 1;
    ilast = 0;

    for (int ib = 0; ib < nbuses; ib++)
    {
        conmod = conmod + sens[ib] * pload[ib];
        ig = preffrst[ib];

        while (ig != 0)
        {
            ilast = ilast + 1;
            amat[nclin][ilast] = sens[ib];
            ig = prefnext[ig];
        }
    }

    if (ilast != nvar)
    {
        printf("***** ERROR IN ADDBRC *****");
    }

    // Enter upper and lower constraints
    bl[nvar + nclin] = conmod - ratea[il] + told[2];
    bu[nvar + nclin] = conmod + ratea[il] - told[2];

} // End addbrc