/* This routine:
    1. Sets up the balance constraint between the load and generation
    2. Sets up the cost vector for the optimization
    3. Sets up the variable limits 
*/

__declspec(dllexport) void balcon(int nvar, int nclin, double *cvec, int mrowa, double **amat, double *bl, double *bu, int *preffrst, int *prefnext, double *prefcost, double *prefmw, int nbuses, int *igbus, double *pload, double *akoeff)
{

    /* Local variables */
    double tload;
    int nseg, ig, ib, ilast;

    nvar = 0;
    nclin = 1;
    tload = 0.0;
    ilast = 0;

    for (ib = 0; ib < nbuses; ib++)
    {
        tload = tload + pload[ib];
        ig = preffrst[ib];
        while (ig != 0)
        {
            ilast = ilast + 1;
            cvec[ilast] = prefcost[ig];
            if (prefmw[ig] > 0.0)
            {
                amat[nclin][ilast] = akoeff[ib];
                bl[ilast] = 0.0;
                bu[ilast] = prefmw[ig];
            }
            else
            {
                amat[nclin][ilast] = 1.0 / akoeff[ib];
                bu[ilast] = 0.0;
                bl[ilast] = prefmw[ig];
            }
            ig = prefnext[ig];
        }
    }

    nvar = ilast;
    bu[nclin + nvar] = tload;
    bl[nclin + nvar] = tload;

} // End balcon