/* The routine builds a linked list from input lists */

__declspec(dllexport) void bulilist(int nbuses, int *ibus, double *price, double *maxmw, int *segtyp, int nseg, int *preffrst, int *prefnext, double *prefcost, double *prefmw, int *preftyp)
{
    // Local variables
    int is, ib;

    // Initialise
    for (is = 0; is < nbuses; is++)
    {
        preffrst[is] = 0;
    }

    for (is = 0; is < nseg; is++)
    {
        prefnext[is] = 0;
    }

    int ipos = -1, inext;

    // Build List
    for (is = 0; is < nseg; is++)
    {
        ipos = ipos + 1;
        ib = ibus[is];
        inext = preffrst[ib];
        if (inext == 0)
        {
            preffrst[ib] = ipos;
        }
        else
        {
            while (inext != 0)
            {
                ib = inext;
                inext = prefnext[ib];
            }
            prefnext[ib] = ipos;
        }
        prefmw[ipos] = maxmw[is];
        prefcost[ipos] = price[is];
        preftyp[ipos] = segtyp[is];
    }

} // End bullilist
