
#include "topflow.h"
#include "dcflow.h"

__declspec(dllexport) void secc_opt(int lout, int nbuses, int ngens, int nlines, int *igbus, double *pload, double *pgen, double *psell, double *pbuy, int *ifromb, int *itob, int *ickt, double *xinv, int *istat, double *ratea, int *ibusno, int *ibus, double *price, double *maxmw, int *segtyp, int nseg, int lmess, int rmext, int *preffrst, int *prefnext, double *prefcost, double *prefmw, int *preftyp, double *teta0, double *basflow, double *cincr, int icont, int nicont, int ibuild, double *a, int *irn, int *icn, int nz, int nsteps, int *ikeep, int iflag, int *iw, int *iw1, int maxfrt, double *w, int la, int *wconct, int *wbus, double *akoeff, double sbase, int *busnam)
{
    /* Security constrained dispatch */

    // Build linked list of the variable description
    // All variables are ordered in a linked list to an approriate description for each bus

    bulilist(nbuses, ibus, price, maxmw, segtyp, nseg, preffrst, prefnext, prefcost, prefmw, preftyp);

    // Build the system description and factorize
    // If "nlines" is less or equal to 1 no network is involved and no network analysis is performed
    // If "ibuild" is 0 and adequate description is already made

    if (nlines > 1 && ibuild != 0)
    {
        //initial(lout, a, irn, icn, nz, nsteps, ikeep, iflag, iw, iw1, maxfrt, w, liw, la, nbuses, istat, ifromb, itob, ickt, xinv, nlines);
    }

    int ik = 0, ncnow;
    int nlcold = 0;

    // Security constrained dispatch
    do
    {
        // Solve the main problem without any contingency analysis
        master(nbuses, ngens, nlines, igbus, preffrst, prefnext, prefcost, prefmw, preftyp, pload, cincr, pbuy, psell, pgen, teta0, ifromb, itob, xinv, istat, ratea, basflow, nlcold, ibusno, wconct, wbus, akoeff, ickt, sbase, busnam);

        // Skip the analysis of no network involved:
        if (icont != 0 && nlines > 1)
        {
            break;
        }

        // Contingency evaluation and constraint generation
        ik = ik + 1;
        printf("Contingency evaluation number: ", ik);

        if ((icont != 0) && (nlines > 1) && (ik <= nicont))
        {
            ncnow = nlcold;

            // coeval(nbuses, nlines, preffrst, prefnext, pload, ifromb, itob, xinv, istat, basflow, nlcold, ickt, ibusno, ratea, lmess, rmext, wconct, wbus, sbase, busnam);

        } //if

    } while (nlcold > ncnow);

} // END secc_opt