/* Update upper and lower constraints if the problem is infeasible. The option is only used when the constraints con not be satisfied. The constranits are updated due to the close to optimal solution returned from the nag-routine. */
#include "topflow.h"

__declspec(dllexport) void upcon(int nvar, int nclin, int mrowa, double **amat, double *bl, double *bu, double *x, int *istate, double *told)
{
    double value, resid;

    for (int is = 0; is < nclin; is++)
    {
        value = 0.0;
        if (istate[nvar + is] >= 0)
        {
            continue;
        }
        for (int ib = 0; ib < nvar; ib++)
        {
            value = value + amat[is][ib] * x[ib];
        }
        if (istate[nvar + is] == -1)
        {
            resid = ABS(bu[nvar + is]) - ABS(value);
            bu[nvar + is] = value + told[2];
        }
        else if (istate[nvar + is] == -2)
        {
            resid = ABS(bl[nvar + is]) - ABS(value);
            bl[nvar + is] = value - told[2];
        }
    }

} // End upcon