__declspec(dllexport) void update(int nbuses, int ngens, double *cincr, double *pbuy, double *psell, double *pgen, int *igbus, int *preffrst, int *prefnext, int *preftyp, int nvar, double *clamda, double *cvec, double *x)
{

    /* The algorithm concludes the result from the optimization program */

    // Initialize generation vectors
    for (int ib = 0; ib < nbuses; ib++)
    {
        cincr[ib] = 0.0;
        pbuy[ib] = 0.0;
        psell[ib] = 0.0;
    }

    for (int ig = 0; ig < ngens; ig++)
    {
        pgen[ig] = 0.0;
    }

    // Update all variables
    int ilast = 0;
    for (int ib = 0; ib < nbuses; ib++)
    {
        int is = preffrst[ib];
        while (is != 0)
        {
            ilast = ilast + 1;
            if (preftyp[is] == 1)
            {
                psell[ib] = psell[ib] - x[ilast];
            }
            else if (preftyp[is] == 2)
            {
                pbuy[ib] = pbuy[ib] + x[ilast];
            }
            else if (preftyp[is] == 3)
            {
                ig = igbus[ib];
                pgen[ig] = pgen[ig] + x[ilast];
            }
            else
            {
                printf("Error in vector - preftyp");
            }

            cincr[ib] = clamda[ilast] - cvec[ilast];
            is = prefnext[is];
        }
    }

    if (ilast != nvar)
    {
        printf("*** ERROR IN UPDATE ***");
    }
}

// End update
