C----------------------------------------------------------------C
C LIBRARY: MASTERLIB  ! PROGRAM RESPONSIBLE:        !  Date:     C
C PROG.SYS: SECCON    !        OLAV BJARTE FOSSO    !  10.05.89  C
C----------------------------------------------------------------C

      SUBROUTINE ADDBRC(IL,NCLIN,NVAR,MROWA,AMAT,BL,BU,SENS,
     &                  PREFFRST,PREFNEXT,TOLD,
     &                  NBUSES,IFROMB,ITOB,IGBUS,XINV,PLOAD,RATEA)
C----------------------------------------------------------------C
C DESCRIPTION:                                                   C
C     THE ROUTINE ADDS A LINEAR CONSTRAINT TO THE OPTIMIZATION   C
C     PROBLEM FOR A VIOLATED BRANCH.                             C
C                                                                C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C  COMMENTS:                                                     C
C                                                                C
C================================================================C

C----------------------------------------------------------------C
C        DECLARATION OF MAIN VARIABLES                           C
C----------------------------------------------------------------C

      INTEGER*4 NCLIN           , MROWA             , NVAR

      INTEGER  PREFFRST(*)      , PREFNEXT(*)       , NBUSES         ,
     &         IFROMB(*)        , ITOB(*)           , IGBUS(*)       ,
     &         IL            

      REAL*8   AMAT(MROWA,*)    , BL(*)             , BU(*)          ,
     &         SENS(*)

      REAL     XINV(*)          , RATEA(*)          , PLOAD(*)       ,
     &         TOLD(*)       

C----------------------------------------------------------------C

C----------------------------------------------------------------C
C        DECLARATION OF LOCAL VARIABLES                          C
C----------------------------------------------------------------C


C----------------------------------------------------------------C


C
C
C  CALCULATE THE SENSITIVITY
C

      DO 100 IB = 1, NBUSES
         SENS(IB) = 0.0
100   CONTINUE

      IFR = IFROMB(IL)
      ITB = ITOB(IL)
      SENS(IFR) = XINV(IL)
      SENS(ITB) = - XINV(IL)
      CALL SOLVB(SENS,NBUSES)

C
C
      CONMOD = 0.0
      NCLIN = NCLIN + 1
      ILAST = 0
      DO 200 IB = 1,NBUSES
        CONMOD  = CONMOD + SENS(IB)*PLOAD(IB)
        IG = PREFFRST(IB)
190     IF (IG .EQ. 0) GOTO 200
        ILAST = ILAST + 1
        AMAT(NCLIN,ILAST) = SENS(IB)
        IG = PREFNEXT(IG)
        GOTO 190
200   CONTINUE
C
      IF (ILAST .NE. NVAR) WRITE(*,*) ' ***** ERROR IN ADDBRC *****'

C
C  ENTER UPPER AND LOWER CONSTRAINTS
C
      BL(NVAR + NCLIN) = CONMOD - RATEA(IL) + TOLD(2)
      BU(NVAR + NCLIN) = CONMOD + RATEA(IL) - TOLD(2)

C
C
C   END
C

      END

