C
C
C  A ROUTINE DOES:
C    1. SETS UP THE BALANCE CONSTRAINT BETWEEN THE LOAD AND GENERATION
C    2. SETS UP THE COST VECTOR FOR THE OPTIMIZATION.
C    3. SETS UP THE VARIABLE LIMITS
C
C

      SUBROUTINE BALCON(NVAR,NCLIN,CVEC,MROWA,AMAT,BL,BU,
     &                  PREFFRST,PREFNEXT,PREFCOST,PREFMW,
     &                  NBUSES,IGBUS,PLOAD,AKOEFF)

C
C  DECLARATIONS
C

      INTEGER*4 NVAR            , NCLIN             , MROWA

      INTEGER  NBUSES           , IGBUS(*)          , PREFFRST(*)    ,
     &         PREFNEXT(*)

      REAL*8   CVEC(*)          , AMAT(MROWA,*)     , BL(*)          ,
     &         BU(*)

      REAL     PREFCOST(*)      , PREFMW(*)         ,
     &         PLOAD(*)         , AKOEFF(*)
C   
C
C   LOCAL DECLARATIONS
C
      REAL     TLOAD
      INTEGER NSEG              , IG                , IB

C
C
C
      NVAR = 0
      NCLIN = 1
      TLOAD = 0.0
      ILAST = 0
C
      DO 200 IB = 1,NBUSES
        TLOAD = TLOAD + PLOAD(IB)
        IG = PREFFRST(IB)
190     IF (IG .EQ. 0) GOTO 200
        ILAST = ILAST + 1
        CVEC(ILAST) = PREFCOST(IG)
        IF (PREFMW(IG) .GT. 0.0) THEN
           AMAT(NCLIN,ILAST) = AKOEFF(IB)
           BL(ILAST)  =  0.0 
           BU(ILAST)  =  PREFMW(IG)    
        ELSE
           AMAT(NCLIN,ILAST) = 1.0/AKOEFF(IB)
           BU(ILAST)  =  0.0 
           BL(ILAST)  =  PREFMW(IG)    
        ENDIF
        IG = PREFNEXT(IG)
        GOTO 190
200   CONTINUE
      NVAR = ILAST
      BU(NCLIN+NVAR) = TLOAD
      BL(NCLIN+NVAR) = TLOAD

C
C
C   END
C

      END
