C----------------------------------------------------------------C
C LIBRARY: MASTERLIB  ! PROGRAM RESPONSIBLE:        !  Date:     C
C PROG.SYS: SECCON    !        OLAV BJARTE FOSSO    !  09.03.91  C
C----------------------------------------------------------------C

      SUBROUTINE COEVAL(NBUSES,NLINES,PREFFRST,PREFNEXT,PINIT,
     &           IFROMB,ITOB,XINV,ISTAT,BASFLOW,NLCOLD,
     &           ICKT,IBUSNO,RATEA,LMESS,RMEXT,WCONCT,WBUS,SBASE,
     &           BUSNAM)
C----------------------------------------------------------------C
C DESCRIPTION:                                                   C
C     THE ROUTINE PERFORMS A LINEAR SCREENING OF ALL SINGLE      C
C     BRANCH OUTAGES WITH AN EXEPTION OF THOSE CAUSING           C
C     SEPARATION                                                 C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C  COMMENTS:                                                     C
C                                                                C
C================================================================C
C  NAME  !   TYPE  !  COMMENT                                    C
C----------------------------------------------------------------C
C GLOBAL VARIABLES:                                              C
C                                                                C
C                                                                C
C COMMON BLOCKS                                                  C

      INCLUDE '../common/param.cmn'
      INCLUDE '../common/contproc.cmn'
      INCLUDE '../common/cominfo.cmn'

      COMMON / REMED / IGCAND(20),  NMOD , ILC
      INTEGER  IGCAND, NMOD, ILC
C----------------------------------------------------------------C
C  INPUTDATA:                                                    C
C----------------------------------------------------------------C
C  NAME  !   TYPE  !  COMMENT                                    C
C----------------------------------------------------------------C
C                                                                C
C                                                                C
C                                                                C
C                                                                C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C  OUTPUTDATA:                                                   C
C----------------------------------------------------------------C
C  NAME  !   TYPE  !  COMMENT                                    C
C----------------------------------------------------------------C
C                                                                C
C                                                                C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C  LOCAL VARIABLES:                                              C
C----------------------------------------------------------------C
C  NAME ! TYPE ! COMMENT                                         C
C----------------------------------------------------------------C
C                                                                C
C                                                                C
C                                                                C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C        DECLARATION OF MAIN VARIABLES                           C
C----------------------------------------------------------------C
C
      INTEGER     NBUSES     , NLINES    , PREFFRST(NBUSES)          ,
     &            PREFNEXT(*)  , IFROMB(NLINES)  , ITOB(NLINES)      ,
     &            ISTAT(NLINES) , ICKT(NLINES), IBUSNO(NBUSES)       ,
     &            WCONCT(*)     , WBUS(*)
C
      REAL        XINV(NLINES) , BASFLOW(NLINES) , PINIT(NBUSES) ,
     &            RATEA(NLINES)

      CHARACTER*8  BUSNAM(NBUSES)
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C        DECLARATION OF LOCAL VARIABLES                          C
C----------------------------------------------------------------C

      INTEGER  IBOUT            , IB                 , IWORST     ,
     &         I                , J                  , K          ,
     &         L                , IVOVL(30)          , NOVL       ,
     &         ICSEP(MAXBUS1)    , IVRES(30)          , NRES       ,
     &         IDUM            

      REAL*8   RHS(MAXBUS1)      , CVEC(MVAR)        , CLAMDA(MCTOTL)  

      REAL     POSTFL(MAXLIN1)   , DINV               , PWORST       ,
     &         DUMOBJ           , PGUSED(30)         , PRMIN(30)    ,
     &         PRMAX(30)        , PCMIN(30)          , PCMAX(30)

C----------------------------------------------------------------C

      RMULT = RMEXT

C
C INITIALIZE SEPARATION COUNTER
C
      NSEP = 0
C
C DEFINE DUMMY CAPACITY
C
      DO 25 I = 1,ILC
         PRMIN(I) = 20.0
         PRMAX(I) = 20.0
25    CONTINUE
C
C
C  CHECK ALL CONTINGENCIES
C

      DO 500 IBOUT = 1,NLINES
        IF (WCONCT(IBOUT) .EQ. 0) GOTO 500
        IF (ISTAT(IBOUT) .NE. 1) GOTO 500
        IF (ABS(BASFLOW(IBOUT)) .LT. TOLD(2)) GOTO 500

        I = IFROMB(IBOUT)
        J = ITOB(IBOUT)

C
C
C  CALCULATE REQUIRED INVERSE FACTORS
C

      DO 100 IB = 1,NBUSES
         RHS(IB) = 0.0
100   CONTINUE

      RHS(I) = 1.0
      RHS(J) = - 1.0

      CALL SOLVB(RHS,NBUSES)

C
C   CALCULATE COMPENSATION
C

      DINV = (1.0 - XINV(IBOUT)*(RHS(I) - RHS(J)))/BASFLOW(IBOUT)

      IF (ABS(DINV) .LE. TOLD(1)) THEN
        NSEP = NSEP + 1
        ICSEP(NSEP) = IBOUT
        GOTO 500
      ENDIF
C
C  FIND FLOW
C
      IWORST = 0
      PWORST = 0.0
      POSTFL(IBOUT) = 0.0
      NOVL = 0

      DO 400 IB = 1,NLINES
        IF (ISTAT(IB) .NE. 1) GOTO 400
        IF (IB .EQ. IBOUT) GOTO 400
        K = IFROMB(IB)
        L = ITOB(IB)
        IF ((WBUS(K) .EQ. 0) .OR. (WBUS(L) .EQ. 0)) GOTO 400
C
        POSTFL(IB) = BASFLOW(IB) + XINV(IB)*(RHS(K) - RHS(L))/DINV
        DFLOW = ABS(POSTFL(IB)) - RMULT*RATEA(IB)
        IF (DFLOW .LT. TOLD(3)) GOTO 400 
        IF (RATEA(IB) .EQ. 0.0) GOTO 400

C
      POVL = POSTFL(IB)


C
C
C TERMINATE THE CONTINGENCY ANALYSES IF TOO MANY CONSTRAINTS ARE ADDED
C
      IF (NLCOLD .LT. 50) THEN
        IFR = IFROMB(IBOUT)
        ITR = ITOB(IBOUT)
        WRITE(LMESS,222) IBUSNO(IFR), BUSNAM(IFR), IBUSNO(ITR),
     &  BUSNAM(ITR), ICKT(IBOUT),
     &    IBUSNO(K), BUSNAM(K),  IBUSNO(L), BUSNAM(L), ICKT(IB),
     &    POSTFL(IB)*SBASE, RATEA(IB)*SBASE, RMULT
222   FORMAT(1X,'OUTAGED BRANCH : ',I6,1X,A8,3X,I6,1X,A8,3X,I3,/,
     & 8X, 'OVERLOAD ON  : ', I6,1X,A8,3X,I6,1X,A8,I3, 2F8.1,F6.2,/)


        CALL PREVENTIV(IBOUT,IB,RHS,NBUSES,NLINES,IFROMB,ITOB,PINIT,
     &           XINV,POVL,RMULT,RATEA,PREFFRST,PREFNEXT,NLCOLD)
      ELSE
        ISTAT(IBOUT) = 1
        GOTO 999
      ENDIF
C
        NOVL = NOVL + 1
        IVOVL(NOVL) = IB
        IF (DFLOW .GT. PWORST) THEN
           PWORST = DFLOW
           IWORST = IB
        ENDIF
400   CONTINUE

C
C
C
      INS = 1
      IF (INS .EQ. 1) GOTO 500
C
C   SOLVE THE SUBPROBLEM IN ORDER TO FIND BENDERS CUT
C
C
       IF (IWORST .GT. 0) THEN
C          WRITE(LOUT,*) ' '
C          WRITE(LOUT,*) ' SOLVING SUBPROBLEM : '
C          WRITE(LOUT,490) IBUSNO(I), IBUSNO(J), ICKT(IBOUT)
 490       FORMAT(1X,'OUTAGE : ',2I6,I4,/)
CC
CC  UPDATE THE COMPENSATION INFORMATION
CC
CC
           ISTAT(IBOUT) = 0
           NUMOUT = 1
           MULTOUT(1) = IBOUT
           CIJ(NUMOUT) = 1.0/XINV(IBOUT) - (RHS(I) - RHS(J))
           DO 492 IB = 1,NBUSES
              SENSMAT(IB,NUMOUT) = RHS(IB)
 492       CONTINUE
C
CC
CC  DEFINE REMEDIAL ACTIONS IF PERMITTED
CC
C
C          IF (IREMED(IBOUT) .NE. 1) GOTO 495 
C          IF (NMOD .LE. 1) GOTO 495
C          CALL REDREM(IWORST,POSTFL,NUMOUT,IVOVL,NOVL,IVRES,NRES,
C    &        IGCAND,NMOD,ILC,PRMIN,PRMAX,PCMIN,PCMAX,
C    &        ICKT,IBUSNO,XINV,IFROMB,ITOB,RATEA,ISTAT,NBUSES,NLINES)
CC
CC  OUTPUT OF RESCHEDULING UNITS
CC
C        WRITE(LOUT,*) ' RESCHEDULING UNITS'
C        WRITE(LOUT,*) (IBUSNO(IVRES(IS)) , IS = 1,NRES)
C
495       CONTINUE
C
CC
CC  SOLVE THE SUBPROBLEM 
CC
C          CALL   SOLVSUB(IWORST,POSTFL,NUMOUT,NRES,IVRES,
C     &                   PGUSED,CVEC,CLAMDA,DUMOBJ,IDUM,
C     &                   PCMIN,PCMAX,PREFFRST,ICKT,IBUSNO,XINV,
C     &                   IFROMB,ITOB,RATEA,ISTAT,NBUSES,NLINES)
C
CC
CC UPDATE THE POST CONTINGENCY RESCHEDULING
C
CC
           IP = IFIRST(IBOUT) - 1
           DO 510 IS = 1,NRES
             IRESCH(IP+IS) = IVRES(IS)
             PFUSED(IP+IS) = PGUSED(IS)
 510       CONTINUE
           ILAST(IBOUT) = IP + NRES
C
CC
CC   FORM AND ADD BENDERS CUT
CC
C
       IF (IDUM .EQ. 1) THEN
          CALL ADDCUT(CVEC,CLAMDA,DUMOBJ,PREFFRST,PREFNEXT,NLCOLD,    
     &                NBUSES)
       ENDIF
C
       ENDIF
C
C
C
C RESTORE
C
           ISTAT(IBOUT) = 1

500   CONTINUE

999   CONTINUE


C
C  END
C

      END

