
      SUBROUTINE DC_OPT
C
C
C
      INCLUDE '../../nett/readsys/sysdat.cmn'
      INCLUDE '../common/param.cmn'
      INCLUDE '../common/ma27dp.cmn'
      INCLUDE '../common/ecodat.cmn'
C
C
C
      PARAMETER (MSEG = 5000)
      INTEGER    IBUS(MSEG),  SEGTYP(MSEG),  PREFTYP(MSEG),
     &           PREFFRST(MAXBUS),   PREFNEXT(MSEG)    
      REAL       MAXMW(MSEG), PRICE(MSEG), PREFMW(MSEG), PREFCOST(MSEG)
      REAL       PSELL(MAXBUS), PBUY(MAXBUS), AKOEFF(MAXBUS)

      REAL*8     TETA0(MAXBUS)
      REAL       BASFLOW(MAXLIN)
      CHARACTER  CH1*1, FILE1*40, CH2*40
C
C
      INTEGER   TAPNO(MAXLIN), WCONCT(MAXLIN), WBUS(MAXBUS), IMODE
      REAL      PNLOAD(MAXBUS), PROD(MAXGEN), PBLOSS(MAXBUS)
C
        TOLD(1) = 0.01
        TOLD(2) = 0.01
        TOLD(3) = 0.01


      LMESS = 26
      IF (LOUT .EQ. 0) LOUT = 28

      OPEN(LMESS,FILE='message.res',STATUS='UNKNOWN')

C
C Initialize  (Default Monitoring = None, Outages = None)
C
      DO 5 IB = 1, NBUSES
         AKOEFF(IB) = 1.0
         WBUS(IB) = 0
5     CONTINUE

      DO 8 IB = 1, NLINES
        WCONCT(IB) = 0
8     CONTINUE



C
C Select area for contingency and violation checking   
C

      CALL SELAREA(WCONCT,WBUS)

C
C  CALCULATE NET LOAD   (PLOAD - SHUNT)
C
      DO 10 IB = 1, NBUSES
        PNLOAD(IB) = -GL(IB)*VOMAG(IB)**2
10    CONTINUE
C
      ICC = 0
      DO 20 IL = 1,NLINES
        IFR = IFROM(IL)
        ITR = ITO(IL)
        PNLOAD(IFR) = PNLOAD(IFR) - GI(IL)*VOMAG(IFR)**2
        PNLOAD(ITR) = PNLOAD(ITR) - GJ(IL)*VOMAG(ITR)**2
        IF (WCONCT(IL) .GT. 0) ICC = ICC + 1 
20     CONTINUE

C   Estimate the losses and prepare a new load vector
C
       CALL  ESTLOSS(PBLOSS)
       
       PT1 = 0.0
       DO 30 IB = 1, NBUSES
          PNLOAD(IB) = PNLOAD(IB) + PBLOSS(IB)
          PT1 = PT1 + PBLOSS(IB)
30     CONTINUE       

       WRITE(LMESS,32) PT1*SBASE
32     FORMAT(//,' DC Losses Estimate  : ',F12.1, ' MW  ')

C
C  CALCULATE SLACK BUS GENERATION
C
      PSL = 0.0

      DO 40 IB = 1, NBUSES
        PSL = PSL + PNLOAD(IB) + PLOAD(IB)
        IG = GENBUS(IB)
        IF (IG .GT. 0) THEN
           IF (BUSCOD(IB) .EQ. 3) THEN
              IB1 = IB
           ELSE
             PSL = PSL - PG(IG) 
           ENDIF
        ENDIF
40    CONTINUE
C
      IG = GENBUS(IB1)
      PG(IG) = PSL      
      WRITE(LMESS,42) NUMBUS(IB1),BUSNAM(IB1), PSL*SBASE
 42   FORMAT(/,' Slack Bus Estimate : ',I6,2X,A8,F12.1,' MW')
C
C
      DO 50 IB = 1, NBUSES
         PNLOAD(IB) = PNLOAD(IB) + PLOAD(IB)
         IG = GENBUS(IB)
         IF (IG .GT. 0) THEN
            PROD(IG) = 0.0
            PNLOAD(IB) = PNLOAD(IB) - PG(IG)
         ENDIF
50    CONTINUE

C


      CALL  REGOBJ(IELEM,IBUS,PRICE,MAXMW,SEGTYP,IMODE,AKOEFF)
C
      IF (ICC .EQ. 0) THEN
        RMEXT = 1.0
        ICONT = 0
      ELSE
  
        RMEXT = 0.0
108     WRITE(*,109) 
C Read transmission line multiplier   
        READ(*,*,ERR=108) RMEXT
C
179     WRITE(*,180)
C Contingency evaluation
        READ(*,181,ERR=179) CH1

        IF ((CH1 .EQ. 'Y') .OR. (CH1 .EQ. 'y')) THEN
           ICONT = 1
        ELSE
           ICONT = 0
        ENDIF
      ENDIF

109   FORMAT(/,1X,'ENTER TRANSMISSION RATING MULT.',
     &           '  (POST-CONT.)',T60, ': ',$)    
180   FORMAT(/,1X,'CONTINGENCY EVALUATION    (Y/N)',T60,': ',$)
181   FORMAT(A1)


      DO 210 IB = 1,IELEM
          IB1 = IBUS(IB)
C          WRITE(LMESS,211) NUMBUS(IB1) , PRICE(IB), MAXMW(IB)*SBASE,
C     &          SEGTYP(IB), AKOEFF(IB1)
 210   CONTINUE
211   FORMAT(I6,F9.1,F9.1,I4,F10.4)
C
C
C  Calculate the appropriate regulation  
C
590   WRITE(*,600)
600   FORMAT(//,1X,'ENTER FILE NAME OF AREA CONTROL ERRORS (S = SKIP) ',
     &  T60,': ',$)
      READ(*,610,ERR=590) FILE1
610   FORMAT(A40)

      NUMEX = 1
      PEX1 = 0.0
      IF ((FILE1 .NE. 'S') .AND. (FILE1 .NE. 's')) THEN

          OPEN(UNIT=22,FILE=FILE1,STATUS='OLD',ERR=590)      
          IEX1= 0
          IEX2= 0
          READ(22,610) CH2
C Read number of cases
          READ(22,*) NUMEX
      ENDIF  

 615    CONTINUE
C
C Do for all NUMEX
C
        PEX1 = 0.0
      DO 650 IX = 1, NUMEX

C Area control error included?

      IF ((FILE1 .NE. 'S') .AND. (FILE1 .NE. 's')) THEN

C  Remove previous case
         IF (PEX1 .NE. 0) THEN
            PNLOAD(IEX2) = PNLOAD(IEX2) - PEX1
         ENDIF
C Read new case
         READ(22,*) IEX1, PEX1
         PEX1 = PEX1/SBASE

         CALL FINDBUS3(IEX1,IEX2,NBUSES,NUMBUS)
         IF (IEX2 .EQ. 0) THEN
            WRITE(*,*) ' BUS NOT FOUND :', IEX1
            STOP
         ENDIF

C
C Add dummy unit in case of infeasibility
C
C        IBUS(IELEM) = IEX2
C        PRICE(IELEM) = 400.0
C        MAXMW(IELEM) = PEX1
C        SEGTYP(IELEM) = 2

C
C  Update mismatch
C
         IF (IEX2 .NE. 0) THEN
           PNLOAD(IEX2) = PNLOAD(IEX2) + PEX1
         ENDIF
C
      ENDIF


      WRITE(*,680)
680   FORMAT(/,1X,'PERMANENT UPDATE OF POWER INJECTION  (Y/N)',
     &       T60,': ',$)
      READ(*,181) CH1
681   FORMAT(A1)
      IF ((CH1 .EQ. 'Y') .OR. (CH1 .EQ. 'y')) THEN
         IPERM = 1
      ELSE
         IPERM = 0
      ENDIF
C          
    

      NICONT = 5
      IBUILD = 1

      CALL  SECC_OPT(LOUT,NBUSES,NGENS,NLINES,GENBUS,PNLOAD,PROD,
     &       PSELL,PBUY,IFROM,ITO,ICKTID,XINV,IBSTAT,RATEA,NUMBUS,
     &       IBUS,PRICE,MAXMW,SEGTYP,IELEM,LMESS,RMEXT,
     &       PREFFRST,PREFNEXT,PREFCOST,PREFMW,PREFTYP,
     &       TETA0,BASFLOW,CINCR,ICONT,NICONT,IBUILD,
     &       A,IRN,ICN,NZ,NSTEPS,IKEEP,IFLAG,IW,IW1,MAXFRT,W,LIW,NDEV0,
     &       WCONCT,WBUS,AKOEFF,SBASE,BUSNAM)

C
C  
C
      CALL SEPARAT(LOUT)


      IF (IMODE .EQ. 1) THEN
C
C   Minimize deviation from basecase
C      
 
      WRITE(LOUT,300)
      WRITE(*,300)
300   FORMAT(////,8X,'***** Security Constrained Optimization *****',//,
     &  '****  Criteria :  Minimum Deviation From Base Case Conditions',
     &   '  ****',
     &  //,1X,'Bus Id.',T26,'P_g0',T33,'Change',
     &          T44,'P_g',T53,'P_min',T62,'P_max',/,
     &     T26,'(MW)',T35,'(MW)',T44,'(MW)',T53,'(MW)',T62,'(MW)')

      DO 400 IB = 1, NBUSES
        IG = GENBUS(IB)
        IF ((PSELL(IB) .GT. 0.01) .OR. (PBUY(IB) .GT. 0.01)) THEN
           PG0 = PG(IG)
           PG1  = PG(IG) + PBUY(IB) - PSELL(IB)
           WRITE(*,800) NUMBUS(IB), BUSNAM(IB), PG0*SBASE,
     &              (PBUY(IB)- PSELL(IB))*SBASE, PG1*SBASE,
     &              PGMIN(IG)*SBASE, PGMAX(IG)*SBASE
           WRITE(LOUT,800) NUMBUS(IB), BUSNAM(IB), PG0*SBASE,
     &               (PBUY(IB)-PSELL(IB))*SBASE, PG1*SBASE,
     &              PGMIN(IG)*SBASE, PGMAX(IG)*SBASE
C
           IF (IPERM .EQ. 1) PG(IG) = PG1
C
        ENDIF
400   CONTINUE

800   FORMAT(1X,I6,A12,T23,F8.1,T32,F8.1,T41,F8.1,T50,F8.1,T59,F8.1)

      ELSEIF (IMODE .EQ. 2) THEN
C
C  Specified list
C
      WRITE(LOUT,550)  PEX1*SBASE
      WRITE(*,550)  PEX1*SBASE
550   FORMAT(///,12X,'**** Security Constrained Optimization *****',//,
     &  10X,' ***** Criteria : Minimum Regulation  Cost *****',//,
     &  1X,'Area control error : ',F8.1, ' MW',//,
     &  1X,'Busnr',2X,'Busname', T30, 'Increase', T45,'Decrease',/,
     &   T32,'(MW)',T46,'(MW)')
      
      PS1 = 0.0
      PK1 = 0.0
      DO 570 IB = 1, NBUSES
        IF ((PBUY(IB) .GT. 0.01) .OR. (PSELL(IB) .GT. 0.01)) THEN
          IG = GENBUS(IB)
          WRITE(LOUT,565) NUMBUS(IB), BUSNAM(IB), PBUY(IB)*SBASE,
     &             PSELL(IB)*SBASE 
          WRITE(*,565) NUMBUS(IB), BUSNAM(IB), PBUY(IB)*SBASE,
     &             PSELL(IB)*SBASE 
          PS1 = PS1 + PSELL(IB)
          PK1 = PK1 + PBUY(IB)
          IF (IPERM .GT. 0) THEN
             IF (IG .GT. 0)  PG(IG) = PG(IG) - PSELL(IB) + PBUY(IB)
          ENDIF
        ENDIF
565   FORMAT(1X,I5,2X,A8,T30,F8.1,T45,F8.1)
570   CONTINUE

      WRITE(LOUT,580) PK1*SBASE, PS1*SBASE, (PK1-PS1-PEX1)*SBASE
      WRITE(*,580) PK1*SBASE, PS1*SBASE, (PK1-PS1-PEX1)*SBASE
580   FORMAT(/,1X,'Total increase in power injection : ',F10.1,' MW',/,
     &         1X,'Total decrease in power injection : ',F10.1,' MW',/,
     &         1X,'Incremental losses                : ',F10.2,' MW',/)
 
      ENDIF
650   CONTINUE

      CALL SEPARAT(LOUT)
C 
      CLOSE(22)
      CLOSE(LMESS)
C
C   END
C
      END

