C----------------------------------------------------------------C
C LIBRARY: START      ! PROGRAM RESPONSIBLE:        !  Date:     C
C PROG.SYS: SECCON    !        OLAV BJARTE FOSSO    !  14.12.89  C
C----------------------------------------------------------------C

      SUBROUTINE INITIAL(LOUT,A,IRN,ICN,NZ,NSTEPS,IKEEP,IFLAG,IW,
     &                   IW1,MAXFRT,W,LIW,LA,
     &                   NBUSES,ISTAT,IFROMB,ITOB,ICKT,XINV,NLINES)

C----------------------------------------------------------------C
C DESCRIPTION:                                                   C
C     THE ROUTINE INITIALIZES THE SYSTEM DESCRIPTION AND         C
C     FACTORIZES B                                              C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C  COMMENTS:                                                     C
C                                                                C
C================================================================C

C----------------------------------------------------------------C
C        DECLARATION OF MAIN VARIABLES                           C
C----------------------------------------------------------------C

      INTEGER*2  IRN(LA)     , ICN(LA)              , IW(LIW)   , 
     &           IKEEP(NBUSES*3)
C
      INTEGER    IW1(NBUSES*2)   , NSTEPS            , IFLAG         ,
     &           MAXFRT          , NZ                , LIW
C
      REAL*8     A(LA)           , W(NBUSES) 
C
      INTEGER  NBUSES           , NLINES         , ISTAT(NLINES)    ,
     &         IFROMB(NLINES)   , ITOB(NLINES)   , ICKT(NLINES)   
C
      REAL     XINV(NLINES)
C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C        DECLARATION OF LOCAL VARIABLES                          C
C----------------------------------------------------------------C


C----------------------------------------------------------------C

C
C  diagnostics
C
      COMMON/MA27DD/ U, LP, MP, LDIAG

      REAL*8 U
      INTEGER  LP, MP, LDIAG

      LP = LOUT
      MP = LOUT
      LDIAG = 0

C
C
C  INITIALIZATIONS FOR NAG-FO1BRF
C
C

C
C  BUILD SYSTEM DESCRIPTION
C

      CALL BUILDB(A,IRN,ICN,NZ,NBUSES,
     &            ISTAT,IFROMB,ITOB,ICKT,XINV,NLINES)

C
C
C  SYMBOLIC FACTORIZATION OF THE MATRIX
C
      IFLAG = 0

      CALL MA27AD(NBUSES,NZ,IRN,ICN,IW,LIW,IKEEP,IW1,NSTEPS,IFLAG) 

C
C  NUMERICAL FACTORIZATION OF THE MATRIX
C

      CALL MA27BD(NBUSES,NZ,IRN,ICN,A,LA,IW,LIW,IKEEP,NSTEPS,
     &            MAXFRT,IW1,IFLAG)


C
C    END
C

      END

