C----------------------------------------------------------------C
C LIBRARY: MASTERLIB  ! PROGRAM RESPONSIBLE:        !  Date:     C
C PROG.SYS: SECCON    !        OLAV BJARTE FOSSO    !  10.05.89  C
C----------------------------------------------------------------C

      SUBROUTINE REMOVE(IP,NVAR,NCLIN,MROWA,AMAT,BL,BU,ISTATE,ICONP)

C----------------------------------------------------------------C
C DESCRIPTION:                                                   C
C     THE ROUTINE REMOVES CONSTRAINTS WITH CERTAIN ATTRIBUTES    C
C     FROM THE OPTIMIZATION PROBLEM                              C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C  COMMENTS:                                                     C
C                                                                C
C================================================================C
C  NAME  !   TYPE  !  COMMENT                                    C
C----------------------------------------------------------------C
C GLOBAL VARIABLES:                                              C
C                                                                C
C                                                                C
C COMMON BLOCKS                                                  C


C----------------------------------------------------------------C
C  INPUTDATA:                                                    C
C----------------------------------------------------------------C
C  NAME  !   TYPE  !  COMMENT                                    C
C----------------------------------------------------------------C
C  NVAR        I        NUMBER OF VARIABLES                      C
C  MROW        I        MAXIMUM NUMBER OF LINEAR CONSTRAINTS     C
C  IP          I        STATUS TYPE TO REMOVE                    C
C  ICONP()     I        CONSTRAINT IDENTIFIER                    C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C  OUTPUTDATA:   (ALTERED FROM THE INPUTVALUES)                  C
C----------------------------------------------------------------C
C  NAME  !   TYPE  !  COMMENT                                    C
C----------------------------------------------------------------C
C NCLIN        I        NUMBER OF LINEAR CONSTRAINTS             C
C ISTATE()     I        VECTOR OF VARIABLE STATUS IN OPT.        C
C AMAT(,)      R8       MATRIX INCLUDING LINEAR CONSTRAINTS      C
C BU()         R8       VECTOR CONTAINING UPPER LIMITS           C
C BL()         R8       VECTOR CONTAINING LOWER LIMITS           C
C ICONP()      I        CONSTRAINT IDENTIFIER                    C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C  LOCAL VARIABLES:                                              C
C----------------------------------------------------------------C
C  NAME ! TYPE ! COMMENT                                         C
C----------------------------------------------------------------C
C IB       I        VARIABLE FOR AN INTERNAL BUSNUMBER           C
C IG       I        VARIABLE FOR A GENERATOR NUMBER              C
C INCLIN   I        VARIABLE INCLUDING THE INITIAL NCLIN         C
C                                                                C
C----------------------------------------------------------------C

C----------------------------------------------------------------C
C        DECLARATION OF MAIN VARIABLES                           C
C----------------------------------------------------------------C

      INTEGER  NVAR             , NCLIN              , MVAR         ,
     &         ISTATE(*)        , IP                 , ICONP(*)

      REAL*8   AMAT(MROWA,*)    , BL(*)              , BU(*)

C----------------------------------------------------------------C

C----------------------------------------------------------------C
C        DECLARATION OF LOCAL VARIABLES                          C
C----------------------------------------------------------------C

      INTEGER  IB               , IG                 , INCLIN

C----------------------------------------------------------------C

C
C    REMOVE CONSTRAINTS
C
      INCLIN = NCLIN

      DO 500 IB = INCLIN, 1, -1
         IF (ISTATE(IB + NVAR) .NE. IP) GOTO 500
         DO 300 IG = 1,NVAR
            AMAT(IB,IG) = AMAT(NCLIN,IG)
300      CONTINUE
         BU(IB + NVAR) = BU(NCLIN + NVAR)
         BL(IB + NVAR) = BL(NCLIN + NVAR)
         ISTATE(IB + NVAR) = ISTATE(NCLIN + NVAR)
         ICONP(IB) = ICONP(NCLIN)
         NCLIN = NCLIN - 1
500   CONTINUE

C
C
C   END
C

      END

