
      SUBROUTINE SECC_OPT(LOUT,NBUSES,NGENS,NLINES,IGBUS,PLOAD,PGEN,
     &       PSELL,PBUY,IFROMB,ITOB,ICKT,XINV,ISTAT,RATEA,IBUSNO,
     &       IBUS,PRICE,MAXMW,SEGTYP,NSEG,LMESS,RMEXT,
     &       PREFFRST,PREFNEXT,PREFCOST,PREFMW,PREFTYP,
     &       TETA0,BASFLOW,CINCR,ICONT,NICONT,IBUILD,
     &       A,IRN,ICN,NZ,NSTEPS,IKEEP,IFLAG,IW,IW1,MAXFRT,W,LIW,LA,
     &       WCONCT,WBUS,AKOEFF,SBASE,BUSNAM)

C   security constrained dispatch
C
C
C  DECLARATIONS
C
      INTEGER  LOUT             , NBUSES         , NGENS            , 
     &         NLINES           , IGBUS(NBUSES)  , IFROMB(NLINES)   ,
     &         ITOB(NLINES)     , ICKT(NLINES)   , ISTAT(NLINES)    ,
     &         IBUS(NSEG)       , SEGTYP(NSEG)   , NSEG             ,
     &         PREFFRST(NBUSES) , PREFNEXT(*)    , PREFTYP(*)       ,
     &         ICONT            , IBUILD         , IBUSNO(NBUSES)   ,
     &         WCONCT(*)        , WBUS(*)
C
      REAL     PLOAD(NBUSES)    , PGEN(NGENS)    , PSELL(NBUSES)    ,
     &         PBUY(NBUSES)     , XINV(NLINES)   , RATEA(NLINES)    ,
     &         PRICE(NSEG)      , MAXMW(NSEG)    , PREFCOST(*)      ,
     &         PREFMW(*)        , BASFLOW(NLINES), CINCR(NBUSES)    ,
     &         AKOEFF(*)        , SBASE
C
      REAL*8   TETA0(NBUSES)

      CHARACTER*8   BUSNAM(NBUSES)
C
C  VARIABLES FOR THE HARWELL MA27 ROUTINE
C

      INTEGER*2  IRN(LA)         , ICN(LA)           , IW(LIW)      , 
     &           IKEEP(3*NBUSES) 
      INTEGER    IW1(2*NBUSES)   , NSTEPS            , IFLAG         ,
     &           MAXFRT          , NZ                , LIW           ,
     &           LA
      REAL*8     A(LA)           , W(NBUSES)
C


10    CONTINUE
C
C  build linked list of the variable description
C
C  All variables are ordered in a linked list to an appropriate
C  description for each bus.
C

      CALL BULILIST(NBUSES,IBUS,PRICE,MAXMW,SEGTYP,NSEG,
     &    PREFFRST,PREFNEXT,PREFCOST,PREFMW,PREFTYP)
C
C  build the system description  and factorize
C
C  If NLINES is less or equal to 1 no network is involved and no network
C  analysis is performed.
C  If IBUILD is 0 an adequate description is already made.
C
      IF (NLINES .LE. 1) GOTO 100
      IF (IBUILD .EQ. 0) GOTO 100
      CALL INITIAL(LOUT,A,IRN,ICN,NZ,NSTEPS,IKEEP,IFLAG,IW,
     &                IW1,MAXFRT,W,LIW,LA,
     &                NBUSES,ISTAT,IFROMB,ITOB,ICKT,XINV,NLINES)
C

100   CONTINUE
C
      IK = 0
      NLCOLD = 0

C
C
200   CONTINUE
C
C  
C  Solve the main problem without any contingency analysis.
C
C  Base Case
C
      CALL MASTER(NBUSES,NGENS,NLINES,IGBUS,PREFFRST,PREFNEXT,PREFCOST,
     &            PREFMW,PREFTYP,PLOAD,CINCR,PBUY,PSELL,PGEN,
     &            TETA0,IFROMB,ITOB,XINV,ISTAT,RATEA,BASFLOW,NLCOLD,
     &            IBUSNO,LMESS,WCONCT,WBUS,AKOEFF,ICKT,SBASE,BUSNAM)
C
C  skip the contingency analysis
C

      IF (ICONT .EQ. 0) GOTO 999
      IF (NLINES .LE. 1) GOTO 999
C
C  contingency evaluation and constraint generation
C
      IK = IK + 1

      WRITE(LMESS,300) IK
300   FORMAT(/,1X, 'CONTINGENCY EVALUATION NUMBER: ', I3,/) 
      IF (IK .GT. NICONT) GOTO 999

      NCNOW = NLCOLD

      CALL COEVAL(NBUSES,NLINES,PREFFRST,PREFNEXT,PLOAD,
     &           IFROMB,ITOB,XINV,ISTAT,BASFLOW,NLCOLD,
     &           ICKT,IBUSNO,RATEA,LMESS,RMEXT,WCONCT,WBUS,SBASE,
     &           BUSNAM)
       
      IF (NLCOLD .GT. NCNOW) GOTO 200


999   CONTINUE
C
C   END   
C

      END
