# DC_opt_example in lp_solve


from lpsolve55 import *

# Syntax: [ret1, ret2, ...] = lpsolve('functionname', arg1, arg2, ...)

# Create a linear problem lp
lp = lpsolve("make_lp", 0, 4)
lpsolve("set_verbose", lp, IMPORTANT)

# Set the objective function
ret = lpsolve("set_obj_fn", lp, [20, 20, 30, 30])

# Set the linear constraints
ret = lpsolve("add_constraint", lp, [1, -1, 1, -1], EQ, 0)
ret = lpsolve("add_constraint", lp, [0.333, -0.333, -0.333, 0.333], LE, 100 - 60)
ret = lpsolve("add_constraint", lp, [0.333, -0.333, 0.667, -0.667], LE, 100 - 70)
ret = lpsolve("add_constraint", lp, [0.6667, -0.667, 0.333, -0.333], LE, 100 - 110)

# Set names
ret = lpsolve("set_col_name", lp, 1, "dP1+")
ret = lpsolve("set_col_name", lp, 2, "dP1-")
ret = lpsolve("set_col_name", lp, 3, "dP2+")
ret = lpsolve("set_col_name", lp, 4, "dP2-")
ret = lpsolve("set_row_name", lp, 1, "Balance")
ret = lpsolve("set_row_name", lp, 2, "F12")
ret = lpsolve("set_row_name", lp, 1, "F23")
ret = lpsolve("set_row_name", lp, 1, "F13")

# Solve the system and print results
ret = lpsolve("write_lp", lp, "a.lp")
ret = lpsolve("solve", lp)
print(lpsolve("get_objective", lp))
print(lpsolve("get_variables", lp)[0])
print(lpsolve("get_constraints", lp)[0])
lpsolve("delete_lp", lp)

