# test_wrapper.py

import ctypes
import numpy as np
import numpy.ctypeslib as npct
from ctypes import c_int

# Define data types
ar_1d_int = npct.ndpointer(dtype=np.int, ndim=1, flags="CONTIGUOUS")

# Load the library
location = "C:\\Users\\hegek\\Documents\\NTNU\\5\\Master\\test\\numpy"
lib = npct.load_library("test_numpy", location)

# Set the argument types
lib.sum_array.argtypes = [ar_1d_int] + [c_int]
lib.sum_array.restype = c_int

# Define the function
def sum_array(var, size):
    """Wrapper for sum_array from test_numpy.c"""
    return lib.sum_array(var, size)

